extension IDKitList<T extends num> on List<T> {
  /// Get the average of a collection of numbers
  double get average {
    assert(isNotEmpty, 'Number collection cannot be empty!');
    if (length == 1) return first * 1.0;
    return sum / length;
  }

  /// Get the maximum value of a collection of numbers
  T get max {
    assert(isNotEmpty, 'Number collection cannot be empty!');
    if (length == 1) return first;
    sort();
    return last;
  }

  /// Get the minimum value of a collection of numbers
  T get min {
    assert(isNotEmpty, 'Number collection cannot be empty!');
    if (length == 1) return first;
    sort();
    return first;
  }

  /// The sum of all elements of the set of numbers
  T get sum {
    assert(isNotEmpty, 'Number collection cannot be empty!');
    if (length == 1) return first;
    num sum = 0;
    for (final T element in this) {
      sum += element;
    }
    return sum as T;
  }
}
