extension RangeNum<T extends num> on num {
  /// Keep a value within a set range.
  T range({
    double min = double.negativeInfinity,
    double max = double.infinity,
  }) {
    if (this < min) return T is int ? (min.toInt() as T) : (min as T);
    if (this > max) return T is int ? (max.toInt() as T) : (max as T);
    return this as T;
  }
}
