import 'package:flutter/material.dart';

class AlertManager {
  /// 记录添加个数
  late List<String> _list;

  /// 上下文
  late BuildContext _context;
  BuildContext get context => _context;

  /// 是否正在加载
  bool get state => _list.isNotEmpty;

  /// 中间对象
  late OverlayEntry? _overlayEntry;

  /// 对象
  AlertManager._internal() {
    _list = [];
  }

  factory AlertManager() => _instance;
  static AlertManager get instance => _instance;
  static final AlertManager _instance = AlertManager._internal();

  /// 初始化
  AlertManager initContext(BuildContext context) {
    _context = context;
    return this;
  }

  /// 添加
  void addAlert(OverlayEntry? overlayEntry, BuildContext context) {
    _list.add('idkit_alert');
    if (overlayEntry != null && !state) {
      _overlayEntry = overlayEntry;
      Overlay.of(context).insert(overlayEntry);
    }
  }

  /// 删除
  void dismissAlert() {
    if (_list.isNotEmpty) {
      _list.removeLast();
    } else {
      _overlayEntry?.remove();
    }
  }
}
